﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=BLEExample.zip

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Private btnReadData As B4XView
	Private btnDisconnect As B4XView
	Private btnScan As B4XView
	Private lblDeviceStatus As B4XView
	Private lblState As B4XView
	Private pbReadData As B4XLoadingIndicator
	Private clv As CustomListView
	#if B4A
	Private manager As BleManager2
	Private serial As Serial
	Private rp As RuntimePermissions	 
	Dim timBT As Timer
	Dim AStreams As AsyncStreams
	Dim btConnected As Boolean
	#else if B4i
	Private manager As BleManager
	#end if
	Private currentStateText As String = "UNKNOWN"
	Private currentState As Int
	Private connected As Boolean = False
	Private ConnectedName As String
	Private ConnectedServices As List
	Private pbScan As B4XLoadingIndicator
	Dim NordicUARTService, RXCharacteristic, TXCharacteristic As String
	Dim StrName, strID As String
	Dim sf As StringFunctions
	Type MsgIDs(BATTERY_LEVEL As Int, DICE_COLOUR As Int, SET_LED As Int, SET_LED_TOGGLE As Int)
End Sub

Public Sub Initialize
'	B4XPages.GetManager.LogEvents = True
	Dim messageIdentifiers As MsgIDs
	messageIdentifiers.Initialize
	messageIdentifiers.BATTERY_LEVEL = 3
	messageIdentifiers.DICE_COLOUR = 23
	messageIdentifiers.SET_LED = 8
	messageIdentifiers.SET_LED_TOGGLE = 16
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("1")
	B4XPages.SetTitle(Me, "BLE Example")
	manager.Initialize("manager")
	serial.Initialize("serial")
	timBT.Initialize("timBT",5000)
	timBT.Enabled = False
	StateChanged
End Sub

Public Sub StateChanged
	lblState.Text = currentStateText
	If connected Then
		lblDeviceStatus.Text = "Connected: " & ConnectedName
	Else
		lblDeviceStatus.Text = "Not connected"
	End If
	btnDisconnect.Enabled = connected
	btnScan.Enabled = Not(connected)
	pbReadData.Hide
'	pbScan.Hide
	btnReadData.Enabled = connected
	btnScan.Enabled = (currentState = manager.STATE_POWERED_ON) And connected = False
End Sub

Sub btnScan_Click
	#if B4A
	'Don't forget to add permission to manifest
	rp.CheckAndRequest(rp.PERMISSION_ACCESS_FINE_LOCATION)
	Wait For B4XPage_PermissionResult (Permission As String, Result As Boolean)
	If Result = False Then
		ToastMessageShow("No permission", True)
		Return
	End If
	#end if
	pbScan.Show
	StartScan
'	Dim PairedDevices As Map
'	PairedDevices = serial.GetPairedDevices
'	Dim l As List
'	l.Initialize
'	For i = 0 To PairedDevices.Size - 1
'		l.Add(PairedDevices.GetKeyAt(i))
'	Next
'	Dim res As Int
'	res = InputList(l, "Choose device", -1) 'show list with paired devices
'	If res <> DialogResponse.CANCEL Then
''		serial.Connect(PairedDevices.Get(l.Get(res))) 'convert the name to mac address and connect
'		Log(manager.State)
'		Log(manager.STATE_POWERED_OFF)
'		Log(manager.STATE_POWERED_ON)
'		Log(manager.STATE_UNSUPPORTED)
'		Log(PairedDevices.Get(l.Get(res)))
'		manager.Connect("74:DA:EA:A0:26:72")
'	End If
End Sub

Sub btnDisconnect_Click
	manager.Disconnect
	Manager_Disconnected
End Sub

Sub btnReadData_Click
	pbReadData.Show
	clv.Clear
	For Each s As String In ConnectedServices
		manager.ReadData(s)
	Next
End Sub

Sub CreateServiceItem (service As String) As Panel
	Dim pnl As B4XView = xui.CreatePanel("")
	pnl.Color = 0xFF808080
	pnl.SetLayoutAnimated(0, 0, 0, clv.AsView.Width, 30dip)
	Dim lbl As B4XView = XUIViewsUtils.CreateLabel
	lbl.Text = service
	lbl.SetTextAlignment("CENTER", "CENTER")
	lbl.Font = xui.CreateDefaultBoldFont(14)
	pnl.AddView(lbl, 0, 0, clv.AsView.Width, 30dip)
	Return pnl
End Sub

Sub CreateCharacteristicItem(Id As String, Data() As Byte) As Panel
	Dim pnl As B4XView = xui.CreatePanel("")
	pnl.SetLayoutAnimated(0, 0, 0, clv.AsView.Width, 40dip)
	pnl.Color = Colors.White
	Dim lbl As B4XView = XUIViewsUtils.CreateLabel
	lbl.Text = Id
	pnl.AddView(lbl, 0, 0, clv.AsView.Width, 20dip)
	Dim lbl2 As B4XView = XUIViewsUtils.CreateLabel
	Try
		lbl2.Text = BytesToString(Data, 0, Data.Length, "UTF8")
	Catch
		Log(LastException)
		lbl2.Text = "Error reading data as string"
	End Try
	lbl2.TextColor = 0xFF909090
	lbl2.TextSize = 14
	pnl.AddView(lbl2, 0, 20dip, clv.AsView.Width, 20dip)
	Return pnl
End Sub

Sub Manager_StateChanged (State As Int)
	Select State
		Case manager.STATE_POWERED_OFF
			currentStateText = "POWERED OFF"
		Case manager.STATE_POWERED_ON
			currentStateText = "POWERED ON"
		Case manager.STATE_UNSUPPORTED
			currentStateText = "UNSUPPORTED"
	End Select
	currentState = State
	StateChanged
End Sub

Sub Manager_DeviceFound (Name As String, Id As String, AdvertisingData As Map, RSSI As Double)
	Log("Found: " & Name & ", " & Id & ", RSSI = " & RSSI & ", " & AdvertisingData) 'ignore
	If Name = "GoDice_52FAAF_K_v04" Or _
	   Name = "GoDice_CE03C9_B_v04" Then
	    StrName = GetDeviceName(Id)
		Log("Response: " & StrName)
		ConnectedName = Name
		manager.StopScan
		pbScan.Hide
		Log(Id)
		strID = Id
		Log("connecting to " & ConnectedName)
		manager.Connect2(Id, True) 'disabling auto connect can make the connection quicker
	End If
End Sub

Sub GetDeviceName (MacAddress As String) As String
	Dim adapter As JavaObject
	adapter = adapter.InitializeStatic("android.bluetooth.BluetoothAdapter").RunMethodJO("getDefaultAdapter", Null)
	Dim BluetoothDevice As JavaObject = adapter.RunMethod("getRemoteDevice", Array(MacAddress))
	Return BluetoothDevice.RunMethod("getName", Null)
End Sub

Public Sub StartScan
	If manager.State <> manager.STATE_POWERED_ON Then
		Log("Not powered on.")
	Else
		manager.Scan2(Null, False)
	End If
End Sub

Sub Manager_DataAvailable (ServiceId As String, Characteristics As Map)
	pbReadData.Hide
	Log("serviceid: " & ServiceId)
	clv.Add(CreateServiceItem(ServiceId), "")
	If sf.Left(ServiceId, 8) = "6e400001" Then
		NordicUARTService = ServiceId
		Log("Nordic UART Service: " & NordicUARTService)
		For Each id As String In Characteristics.Keys
			Log(id)
			clv.Add(CreateCharacteristicItem(id, Characteristics.Get(id)), "")
			If sf.Left(id, 8) = "6e400002" Then
				RXCharacteristic = id
				Dim iRetRX As Int = manager.GetCharacteristicProperties(NordicUARTService, RXCharacteristic)
				Log("RX Characteristic: " & RXCharacteristic & " Return Value: " & iRetRX)
			End If
			If sf.Left(id, 8) = "6e400003" Then
				TXCharacteristic = id
				Dim iRetTX As Int = manager.GetCharacteristicProperties(NordicUARTService, TXCharacteristic)
				Log("TX Characteristic: " & TXCharacteristic & " Return Value: " & iRetTX)
			End If
		Next	
	Else		
		For Each id As String In Characteristics.Keys
			clv.Add(CreateCharacteristicItem(id, Characteristics.Get(id)), "")
		Next
	End If
'	
	
End Sub

Sub Manager_Disconnected
	Log("Disconnected")
	connected = False
	StateChanged
End Sub

Sub Manager_Connected (services As List)
	Log("Connected " & services)
	connected = True
	ConnectedServices = services
	For Each s As String In ConnectedServices
		manager.ReadData(s)
	Next
	StateChanged
End Sub

Sub Manager_RssiAvailable (Success As Boolean, RSSI As Double)
	Log(Success)
	Log(RSSI)
End Sub

'utility to convert short UUIDs to long format on Android
Private Sub UUID(id As String) As String 'ignore
#if B4A
	Return "0000" & id.ToLowerCase & "-0000-1000-8000-00805f9b34fb"
#else if B4I
	Return id.ToUpperCase
#End If
End Sub



Sub Serial_Connected (Success As Boolean)
	Dim msg As String
	
	If Success = True Then
		ToastMessageShow("Bluetooth connected to " & serial.Address, False)
		AStreams.Initialize(serial.InputStream,serial.OutputStream,"AStreams")
'		SendMessage ("6e400002-b5a3-f393-e0a9-e50e24dcca9e")
		timBT.Enabled = True
	Else	'disconnected
		Log("Connection To " & serial.Address & _
		" broken!")
		ToastMessageShow("Connection to " & serial.Address & _
						" broken!", True)
		timBT.Enabled = False
		btConnected = False
	End If
End Sub

Sub timBT_Tick
	'Communicte with the device here
	'if the device answers, fine
	'if there is no response, communication might be lost
	'Stop the timer and you should call BTConnectToDevice again
End Sub



Public Sub SendMessage (msg As String)
	AStreams.Write(msg.GetBytes("utf8"))
End Sub

Private Sub AStream_NewData (Buffer() As Byte)
	Log(BytesToString(Buffer, 0, Buffer.Length, "UTF8"))
'	CallSub2(ChatActivity, "NewMessage", BytesToString(Buffer, 0, Buffer.Length, "UTF8"))
End Sub

Private Sub AStream_Error
	ToastMessageShow("Connection is broken.", True)
'	ConnectionState = False
'	NotifyOfStateChanged
End Sub
